#pragma once

#include <string>
#include <vector>

#include <RobotAPI/interface/skills/SkillProviderInterface.h>
#include <RobotAPI/libraries/aron/core/type/variant/container/Object.h>

namespace armarx
{
    namespace skills
    {
        struct SkillDescription
        {
            std::string                        skillName;
            std::string                        description;
            std::vector<std::string>           targets;
            long                               timeoutMs;
            aron::type::ObjectPtr              acceptedType;

            provider::dto::SkillDescription toIce() const;
        };
    }
}
